<p align="center">
    <img src="assets/cool_service.png" align="center" width="30%">
</p>
<p align="center"><h1 align="center">📸 CAMERA-SERVICES 📸</h1></p>
<p align="center">
	<em><code>❯ Full camera services dockerized </code></em>
</p>

##  Table of Contents

- [ Overview](#-overview)
- [ Features](#-features)
- [ Project Structure](#-project-structure)
- [ Getting Started](#-getting-started)
  - [ Prerequisites](#-prerequisites)
  - [ Installation](#-installation)
- [ Contributing](#-contributing)
- [ Acknowledgments](#-acknowledgments)
- [ Acess Token](#-acces-token)

---

##  Overview

Camera services include two crucial repositories, the frame acquisition - which is responsible for capturing the frame and send it to the server - and object publisher - so that the analised image outputs to the [ATCLL](https://new.aveiro-living-lab.it.pt/realtime).

Camera services are deployed using [APU playbooks](https://code.nap.av.it.pt/mobility-networks/apu-playbooks), to ensure compatibility and reliability across server and local processing.

---

##  Features

Features can include [Smart Parking](/smart-parking/README.md), [Smart Crosswalk](/smart-crosswalk/README.md) and [Smart Queueing](/smart-queueing/README.md). All the features are of customizable deploy, meaning each Smart Lamp Post can have each service, but previously configuration must be done.

---

##  Project Structure

```sh
└── camera-services.git/
    ├── README.md
    ├── atcll-cameras-info.ini
    ├── docker-compose.yaml
```

---
##  Getting Started

###  Prerequisites

Before getting started with camera-services.git, ensure your runtime environment meets the following requirements:

- **Programming Language:** Python
- **Container Runtime:** Docker


###  Installation

Install camera-services.git using one of the following methods:

**Build from source:**

1. Clone the camera-services.git repository:
```sh
git clone https://code.nap.av.it.pt/atcll/camera-services.git --recurse-submodules
```

2. Navigate to the project directory:
```sh
cd camera-services
```

3. Install the project dependencies:


**Using `docker`** &nbsp; ![Docker](https://img.shields.io/badge/docker-%230db7ed.svg?style=for-the-badge&logo=docker&logoColor=white)

```sh
docker build -t atcll/camera-services .
```

###  Usage
Run camera-services.git using the following command:
**Using `docker`** &nbsp; ![<img align="center" src="![Docker](https://img.shields.io/badge/docker-%230db7ed.svg?style=for-the-badge&logo=docker&logoColor=white)" />](https://www.docker.com/)

```sh
docker compose up {service1} {service2} ... -d 
```

---
##  Project Roadmap

- [X] **`Task 1`**: <strike>Make it good.</strike>
- [ ] **`Task 2`**: Metrics flag implementation.
- [ ] **`Task 3`**: Implement no dependency policy among services.
- [ ] **`Task 4`**: Tests. (this is not tested at all ☢️)

---

##  Contributing

- **💬 Major thanks to**: [Bernardo Barreto](https://www.youtube.com/watch?v=iE3kD4X_Fwg) and [Pedro Almeida](https://www.youtube.com/watch?v=D-UmfqFjpl0).

<details closed>

**Review**: If I like, I approve, if I don't like please refer to the [Complain Book]().
</details>

##  Acess Token

Access token: <code>glpat-wZgVf8pypnbL-TkJUP8c</code>

---